searchData={"items":[{"type":"module","title":"Apple","doc":"Utilities for building Apple SDKs.\n\n> #### Note {: .info}\n>\n> This is not a one-stop, comprehensive SDK. As the description implies, it\n> provides utilities for building your own minimalistic and focused SDK.\n>\n> Read more about this idea at [Ship utilities for building platform SDKs](https://github.com/cozy-elixir/proposals/blob/main/ship-utilities-for-building-platform-sdks.md).","ref":"Apple.html"},{"type":"module","title":"Apple.Types.AppStoreConnect","doc":"Provides App Store Connect related types.","ref":"Apple.Types.AppStoreConnect.html"},{"type":"type","title":"Apple.Types.AppStoreConnect.bundle_id/0","doc":"The app's bundle ID, like `\"com.example.demo\"`.\n\nTo obtain the app's bundle ID, sign into App Store Connect and complete the\nfollowing steps:\n\n  1. Select \"Apps\".\n  2. Select \"App Information\" under the \"General\" section.\n  3. Look up the \"Bundle ID\" on the page.","ref":"Apple.Types.AppStoreConnect.html#t:bundle_id/0"},{"type":"type","title":"Apple.Types.AppStoreConnect.issuer_id/0","doc":"The issuer ID, like `\"57246542-96fe-1a63-e053-0824d011072a\"`\n\nTo obtain the issuer ID, sign into App Store Connect and complete the\nfollowing steps:\n\n  1. Select \"Users and Access\", and then select the \"Integrations\" tab.\n  2. Select the type of \"Keys\" that you need:\n     - App Store Connect API\n     - In-App Purchase\n  3. Look up the \"Issue ID\" on the page.","ref":"Apple.Types.AppStoreConnect.html#t:issuer_id/0"},{"type":"type","title":"Apple.Types.AppStoreConnect.key_id/0","doc":"The private key ID, like `\"2X9R4HXF34\"`.\n\nTo generate a private key, sign into App Store Connect and complete the\nfollowing steps:\n\n  1. Select \"Users and Access\", and then select the \"Integrations\" tab.\n  2. Select the type of \"Keys\" that you need:\n     - App Store Connect API\n     - In-App Purchase\n  3. Click the Generate button or the Add (+) button.\n  4. Enter a name for the key.\n  5. Click the Generate button.\n\nThen, following information appears on the page:\n\n  * the private key's name\n  * the private key ID\n  * the link for downloading the private key\n\n> #### Note {: .info}\n> The name for the key is for your reference only and isn't part of the key itself.\n\n> #### Warning {: .warning}\n> The private key is only available for download a single time.","ref":"Apple.Types.AppStoreConnect.html#t:key_id/0"},{"type":"type","title":"Apple.Types.AppStoreConnect.private_key/0","doc":"The private key associated with the `key_id`.\n\nIt's in PEM format, like:\n\n```text\n-----BEGIN PRIVATE KEY-----\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n...\n-----END PRIVATE KEY-----\n```","ref":"Apple.Types.AppStoreConnect.html#t:private_key/0"},{"type":"type","title":"Apple.Types.AppStoreConnect.shared_secret/0","doc":"The secret for verifying receipt, which is a 32-character hexadecimal string,\nlike `\"10e87024b8b34e699156d1d89bdd6bf0\"`.\n\nThere are two type of shared secrets:\n\n  * primary shared secret, which can be used for all of your apps.\n  * app-specific shared secret, which can only be used for individual apps.\n\nTo obtain a primary shared secret, sign into App Store Connect and complete\nthe following steps:\n\n  1. Select \"Users and Access\", and then select the \"Integrations\" tab.\n  2. Select the \"Shared Secret\" type of \"Keys\".\n  3. Generate or regenerate a shared secret.\n\nTo obtain a app-specific shared secret, sign into App Store Connect and\ncomplete the following steps:\n\n  1. Select \"Apps\".\n  2. Select the app that you want to generate shared secret for.\n  3. Select \"App Information\" under the \"General\" section.\n  4. Look up \"App-Specific Shared Secret\" on the page.\n\n> #### Note {: .info}\n>\n> Considering that App Store Receipts have been deprecated, this so-called\n> shared secret should no longer be used.","ref":"Apple.Types.AppStoreConnect.html#t:shared_secret/0"},{"type":"module","title":"Apple.Types.Developer","doc":"Provides Apple Developer related types.","ref":"Apple.Types.Developer.html"},{"type":"type","title":"Apple.Types.Developer.key_id/0","doc":"The private key ID, like `\"2Y9R5HMY68\"`.\n\nTo obtain the private key ID, sign into Apple Developer and complete the\nfollowing steps:\n\n  1. Navigate to \"Certificates, IDs & Profiles\".\n  2. Navigate to \"Keys\".\n  3. Click the plus button to generate a new private key.","ref":"Apple.Types.Developer.html#t:key_id/0"},{"type":"type","title":"Apple.Types.Developer.private_key/0","doc":"The private key associated with the `key_id`.\n\nIt's in PEM format, like:\n\n```text\n-----BEGIN PRIVATE KEY-----\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n...\n-----END PRIVATE KEY-----\n```","ref":"Apple.Types.Developer.html#t:private_key/0"},{"type":"type","title":"Apple.Types.Developer.service_id/0","doc":"The registered service ID, like `\"com.example.weatherkit\"`.\n\nTo obtain the registered service ID, sign into Apple Developer and complete\nthe following steps:\n\n  1. Navigate to \"Certificates, IDs & Profiles\".\n  2. Navigate to \"Identifiers\".\n  3. Click the plus button to add a new identifier.\n  4. Select \"Service IDs\", and register a service ID.","ref":"Apple.Types.Developer.html#t:service_id/0"},{"type":"type","title":"Apple.Types.Developer.team_id/0","doc":"The team ID, which is a 10-character string, like `\"6MPDV0UYYX\"`\n\nTo obtain the team ID, sign into Apple Developer and complete the following\nsteps:\n\n  1. Navigate to \"Membership details\".","ref":"Apple.Types.Developer.html#t:team_id/0"},{"type":"module","title":"Apple.AppStoreServerAPI","doc":"Utilities for [App Store Server API](https://developer.apple.com/documentation/appstoreserverapi).","ref":"Apple.AppStoreServerAPI.html"},{"type":"function","title":"Apple.AppStoreServerAPI.build_auth_token!/4","doc":"Builds a token to authorize HTTP requests.\n\n> #### Note {: .info}\n> Using a private key of the \"In-App Purchase\" type is sufficient.\n\nAfter building it, use it in the `Authorization` header like this:\n\n```text\nAuthorization: Bearer  \n```","ref":"Apple.AppStoreServerAPI.html#build_auth_token!/4"},{"type":"function","title":"More resources - Apple.AppStoreServerAPI.build_auth_token!/4","doc":"* [Generating JSON Web Tokens for API requests](https://developer.apple.com/documentation/appstoreserverapi/generating_json_web_tokens_for_api_requests)","ref":"Apple.AppStoreServerAPI.html#build_auth_token!/4-more-resources"},{"type":"module","title":"Apple.MapsServerAPI","doc":"Utilities for [Maps Server API](https://developer.apple.com/documentation/applemapsserverapi).","ref":"Apple.MapsServerAPI.html"},{"type":"function","title":"Apple.MapsServerAPI.build_auth_token!/4","doc":"Builds a token to authorize HTTP requests.","ref":"Apple.MapsServerAPI.html#build_auth_token!/4"},{"type":"type","title":"Apple.MapsServerAPI.origin/0","doc":"Something like `\"*.example.com\"`.","ref":"Apple.MapsServerAPI.html#t:origin/0"},{"type":"module","title":"Apple.WeatherKitRestAPI","doc":"Utilities for [WeatherKit REST API](https://developer.apple.com/documentation/weatherkitrestapi).","ref":"Apple.WeatherKitRestAPI.html"},{"type":"function","title":"Apple.WeatherKitRestAPI.build_auth_token!/4","doc":"Builds a token to authorize HTTP requests.\n\nAfter building it, use it in the `Authorization` header like this:\n\n```text\nAuthorization: Bearer  \n```","ref":"Apple.WeatherKitRestAPI.html#build_auth_token!/4"},{"type":"function","title":"More resources - Apple.WeatherKitRestAPI.build_auth_token!/4","doc":"* [Request authentication for WeatherKit REST API](https://developer.apple.com/documentation/weatherkitrestapi/request_authentication_for_weatherkit_rest_api)","ref":"Apple.WeatherKitRestAPI.html#build_auth_token!/4-more-resources"},{"type":"module","title":"Apple.Signed","doc":"Utilities for handling signed payload.","ref":"Apple.Signed.html"},{"type":"function","title":"Apple.Signed.verify/2","doc":"Verifies a signed payload.\n\nSigned payloads are used in the responses of:\n\n  * [App Store Server API](https://developer.apple.com/documentation/appstoreserverapi)\n  * [App Store Server Notifications](https://developer.apple.com/documentation/appstoreservernotifications)\n  * ...","ref":"Apple.Signed.html#verify/2"},{"type":"function","title":"References - Apple.Signed.verify/2","doc":"* https://github.com/potatosalad/erlang-jose/issues/63#issuecomment-1038751471\n  * https://andrealeopardi.com/posts/verifying-apple-jwts/","ref":"Apple.Signed.html#verify/2-references"},{"type":"type","title":"Apple.Signed.payload/0","doc":"The verified payload extracted from signed payload.","ref":"Apple.Signed.html#t:payload/0"},{"type":"type","title":"Apple.Signed.root_cert/0","doc":"The root certificate that Apple offers on [Apple PKI](https://www.apple.com/certificateauthority/).\n\nIt's fine to use _Apple Root CA - G3 Root_.","ref":"Apple.Signed.html#t:root_cert/0"},{"type":"type","title":"Apple.Signed.signed_payload/0","doc":"A cryptographically signed payload, in JSON Web Signature (JWS) format.","ref":"Apple.Signed.html#t:signed_payload/0"},{"type":"extras","title":"Apple","doc":"# Apple\n\n[![CI](https://github.com/cozy-elixir/apple/actions/workflows/ci.yml/badge.svg)](https://github.com/cozy-elixir/apple/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/apple.svg)](https://hex.pm/packages/apple)\n\nUtilities for building Apple SDKs.","ref":"readme.html"},{"type":"extras","title":"Installation - Apple","doc":"Add `:apple` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:apple,  }\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Apple","doc":"For more information, see the [documentation](https://hexdocs.pm/apple).","ref":"readme.html#usage"},{"type":"extras","title":"License - Apple","doc":"[Apache License 2.0](https://www.apache.org/licenses/LICENSE-2.0)","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"unreleased - Changelog","doc":"","ref":"changelog.html#unreleased"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"- add support for [Apple Maps Server API](https://developer.apple.com/documentation/applemapsserverapi/)","ref":"changelog.html#v0-5-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}